#!/bin/bash

LANG=C

stripdomain () {
  # echo "stripdomain:\$*:$*" >&2
  local dom=$1
  local func=$2
  shift 2
  # echo "stripdomain: called dom:$dom func:$func" >&2
  dom="${dom%.}."
  while [ -n "$dom" ]; do
    # echo stripdomain: exec $func $dom $* >&2
    $func $dom $* && break
    dom=${dom#*.}
  done
}

getattribute () {
  # echo "getattributebyname:\$*:$*" >&2
  local attribute=""
  local attributevalue=""
  
  local objectname=$1
  local attributename=$2
  # echo "objectname:$objectname attributename:$attributename" >&2
  
  if [ -n "$attributename" ]; then
    # echo attributename not empty
    attribute=$(dig +short $objectname txt | grep "\"$attributename=" | sed -e "s/ /ß/g")
    if [ -n "$attribute" ]; then
      # echo attribute:$attribute >&2
      # IFS=''
      for attributevalue in $attribute; do
	# echo "  attributevalue:§$attributevalue§" >&2
	attributevalue=${attributevalue#*=}
	attributevalue=${attributevalue%\"}
	# echo "  attributevalue:§$attributevalue§" >&2
	attributevalue=$(echo "$attributevalue" | sed -e "s/ß/ /g")
	echo "\"$attributevalue\""
      done
      # unset IFS
      return 0
    fi
  else
    attribute=$(dig +short $objectname txt)
    if [ -n "$attribute" ]; then
      echo $attribute
      return 0
    fi
  fi
  return 1
}

getattributebyname () {
  # echo "getattributebyname:\$*:$*" >&2
  local opt OPTIND OPTARG
  local recursive=0
  local attribute=""
  local attributevalue=""
  
  while getopts "r" opt; do
    case $opt in
      r)
	recursive=1
	;;
    esac
    # echo "opt:$opt OPTARG:$OPTARG OPTIND:$OPTIND" >&2
  done
  shift $((OPTIND-1))
  
  local objectname=$1
  local attributename=$2
  # echo "objectname:$objectname attributename:$attributename" >&2
  
  if [ $recursive -ne 0 ]; then
    # echo "recursive" >&2
    stripdomain $objectname getattribute $attributename; return $?
  else
    # echo "notrecursive" >&2
    # a=$(getattribute $objectname $attributename)
    # echo "a='$a'" >&2
    getattribute $objectname $attributename && return 0
  fi
  return 1
}

